<template>
  <div>
    <ob-table
      :columns="tableColumns"
      :functionalPanel="false"
      :remote-opt="{
        method: getDrivers
      }"
      :tableLayoutFixed="false"
      :isSmartPagination="false"
      :rowClassFunc="getRowClass"
      data-qa="LogisticDomainsAgentDriversTable"
      ref="obTableAgentDrivers"
      @select="onSelectItem"
    >

    <template v-slot:risk="{ data }">
      <i :class="['icon', data.item.isActive ? $options.riskColorsMap[data.item.riskGroupColor] : 'clock']"></i>
    </template>

    <template v-slot:status="{ data }">
      {{ data.item.isActive ? 'Активно' : 'Неактивно' }}
    </template>

    </ob-table>
  </div>
</template>

<script>
import api from "@/api";
import obTable from 'common-components/src/obComponents/obTable';

  export default {
    name: 'agentDriversComponent',

    riskColorsMap: {
      'GREEN': 'risk-1-blue',
      'BLUE': 'risk-2-green',
      'YELLOW': 'risk-3-yellow',
      'ORANGE': 'risk-4-orange',
      'RED': 'risk-5-red',
      'BLACK': 'risk-6-black'
    },

    components: {
      obTable
    },

    mounted() {
      console.log('drivers tab mounted');
    },

    computed: {
      tableColumns() {
        return [
          {
            title: 'группа риска',
            key: 'riskGroupColor',
            slotName: 'risk'
          },
          {
            title: 'ФИО',
            key: 'fio'
          },
          {
            title: 'Номер Водительского удостоверения',
            key: 'driverLicenseNumber'
          },
          {
            title: 'Номер телефона',
            key: 'phone'
          },
          {
            title: 'статус',
            key: 'isActive',
            slotName: 'status'
          }
        ]
      }
    },
    
    methods: {
      async getDrivers({page, size}) {
        const res = await api.linkBrowser.getAgentResource({
          type: 'drivers',
          uuid: this.$route.params.id,
          page,
          size
        });
        return {
          content: res.content.drivers,
          number_of_elements: res.number_of_elements,
          page: res.page,
          size: res.size,
          total_elements: res.total_elements,
          total_pages: res.total_pages
        }
      },

      getRowClass (data) {
        return data.item.isActive ? '' : '--removed'
      },

      onSelectItem(item) {
        this.$router.push({
          path: '/sb_resource/' + item.uuid
        });
      }
    }
  }
</script>

<style lang="scss" scoped>
@import "~common-components/src/static/css/variables";
@import "~common-components/src/static/css/mixins";

::v-deep {
  .--removed td > .td-container {
    color: $color-grey-span
  }
}
</style>